import os

from botcity.maestro import *
from botcity.web import Browser, By, WebBot
from webdriver_manager.chrome import ChromeDriverManager

BotMaestroSDK.RAISE_NOT_CONNECTED = False


def main():
    # Instancia do Orquestrador
    maestro = BotMaestroSDK.from_sys_args()
    execution = maestro.get_execution()
    
    # Usuário e senha para acessar o site
    username = "Admin"
    password = "admin123"

    # Instancia do bot
    bot = WebBot()

    # Configura o modo headless para False
    bot.headless = False

    # Define o navegador a ser utilizado
    bot.browser = Browser.CHROME

    # Instala a versão mais recente do ChromeDriver
    bot.driver_path = ChromeDriverManager().install()

    try:
        print("Iniciando a execução")

        # Acessa o site OrangeHRM
        bot.browse("https://opensource-demo.orangehrmlive.com/web/index.php/auth/login")

        # Função que faz o login
        fazer_login(bot, username, password)

        # Busca e clica pela pagina de recrutamento
        aba_recruitment = bot.find_element(
            '#app > div.oxd-layout > div.oxd-layout-navigation > aside > nav > div.oxd-sidepanel-body > ul > li:nth-child(5) > a',
            by=By.CSS_SELECTOR)
        aba_recruitment.click()
            
        # Busca e clica no campo de status
        field_status = bot.find_element(
            '#app > div.oxd-layout > div.oxd-layout-container > div.oxd-layout-context > div > div.oxd-table-filter > div.oxd-table-filter-area > form > div:nth-child(1) > div > div:nth-child(4) > div > div:nth-child(2) > div > div > div.oxd-select-text--after > i',
            by=By.CSS_SELECTOR)
        field_status.click()

        # Aguarda 1 segundo e seleciona a opção "Intervier scheduled" com o teclado
        bot.wait(1000)
        bot.type_down()
        bot.type_down()
        bot.type_down()
        bot.type_down()
        bot.enter()

        # clicar no botão de pesquisa
        button_search = bot.find_element('#app > div.oxd-layout > div.oxd-layout-container > div.oxd-layout-context > div > div.oxd-table-filter > div.oxd-table-filter-area > form > div.oxd-form-actions > button.oxd-button.oxd-button--medium.oxd-button--secondary.orangehrm-left-space', by=By.CSS_SELECTOR)
        button_search.click()

        # Busca pelos candidatos
        lista_candidatos = bot.find_elements(
            '//*[@id="app"]/div[1]/div[2]/div[2]/div/div[2]/div[3]/div/div[2]/div[*]/div/div[7]/div/button[1]',
            by=By.XPATH)

        # Percorre a lista de candidatos
        for index, candidato in enumerate(lista_candidatos):
            # Busca pelo nome da pessoa candidata
            nome = bot.find_element(f'//*[@id="app"]/div[1]/div[2]/div[2]/div/div[2]/div[3]/div/div[2]/div[{index+1}]/div/div[3]/div', by=By.XPATH)
            nome = nome.text
            print(nome)

            # Clica nas informações do candidato e aguarda 2 segundos
            candidato.click()
            bot.wait(2000)
            
            # Busca pelo botão de download do curriculo e aguarda 2 segundos
            download = bot.find_element(
                '#app > div.oxd-layout > div.oxd-layout-container > div.oxd-layout-context > div.orangehrm-background-container > div > form > div:nth-child(5) > div > div > div > div:nth-child(2) > div > div',
                by=By.CSS_SELECTOR)
            bot.wait(2000)

            # Verifica se existe curriculo e faz as ações necessárias
            if download:
                download.click()
                print("Baixando o curriculo")
                bot.wait(2000)
                for arquivo in os.listdir():
                    if arquivo.endswith(".pdf") or arquivo.endswith(".docx"):
                        print(f"Baixou o curriculo: {arquivo}")
                        print(f"Faz a manipulação")
            
                        # Aguarda 2 segundos e deleta o arquivo
                        print(f"Deletando o arquivo: {arquivo}")
                        bot.wait(2000)
                        os.remove(arquivo)
                        break
            else:
                print("Não encontrou o curriculo")
            bot.wait(2000)
            
            # voltar a pagina
            bot.back()
            bot.wait(2000)

    except Exception as e:
        print("Erro ao executar o bot")
        print(e)

    finally:
        # Aguarda 3 segundos e fecha o navegador
        bot.wait(3000)
        bot.stop_browser()

        print("Fim da execução")


def fazer_login(bot, username, password):
    element_user = "div.oxd-form-row:nth-child(2) > div:nth-child(1) > div:nth-child(2) > input:nth-child(1)"
    element_password = "div.oxd-form-row:nth-child(3) > div:nth-child(1) > div:nth-child(2) > input:nth-child(1)"
    element_button = ".oxd-button"

    bot.find_element(
        element_user,
        by=By.CSS_SELECTOR).send_keys(username)
    bot.find_element(
        element_password,
        By.CSS_SELECTOR).send_keys(password)
    bot.find_element(
        element_button,
        By.CSS_SELECTOR).click()
     
            
if __name__ == '__main__':
    main()
